<template>
	<a-drawer
		:title="'关联主流价格'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId">
				<a-input v-model:value="formData.depotGrainName" disabled/>
			</a-form-item>
			<a-form-item label="粮食种类：" name="grainGroup">
				<a-input v-model:value="formData.grainGroup" disabled/>
			</a-form-item>
			<a-form-item label="出库单价(元/吨)：" name="loanPrice">
				<a-input-number v-model:value="formData.loanPrice" placeholder="请输入出库单价" :min="0.01" style="width:100%" disabled allow-clear/>
			</a-form-item>
			<a-form-item label="主流地价格信息：" name="zonePriceId">
				<a-select v-model:value="formData.zonePriceId" placeholder="请选择" :options="zonePriceIdOptions"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotGrainInfoPriceForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotGrainInfoPriceApi from '@/api/biz/depotGrainInfoPriceApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const zonePriceIdOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
	dictOptionsApi.options(Object.assign('', {'dictValue': '主流价格', 'grainGroup': formData.value.grainGroup})).then((data) => {
		zonePriceIdOptions.value = data
	})
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入')],
	grainGroup: [required('请输入')],
	avgPrice: [required('请输入')],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotGrainInfoPriceApi
				.depotGrainInfoPriceSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
